<?php
/**
 * JComments application for Joomunity component
 *
 * @version 1.0
 * @package JComments
 * @subpackage Joomunity
 * @author Sergey M. Litvinov (smart@joomlatune.ru)
 * @copyright (C) 2006-2009 by Sergey M. Litvinov (http://www.joomlatune.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 */

defined('_JOOM_INC') or die(JText::_('JOOMRESTRICTEDACCESS'));

class jcomments_controller extends joom_controller
{

    var $joomunity;
    var $user = null;
    var $uSettings = null;
    var $sSettings = null;

    function comments_controller($JOOMUNITY)
    {
        global $_CONFIG, $tpl, $mainframe;

        $this->joomunity = &$JOOMUNITY;
        $this->user = &$JOOMUNITY->user();
        $this->sSettings = &$_CONFIG->params("jcomments");
    }

    function all($params, $message = null)
    {
        global $_CONFIG, $JOOMUNITY, $tpl;

        if (!$this->check_params($params, 1)) {
            $title = "INVALID URL PARAMETERS";
            $msg = $this->get_errors();
            $error = $this->gen_error_message($msg, $title);

            return $tpl->set_var("mainbody", $error);
        }

        $params[0] = (empty($params)) ? UID : $params[0];

        $system = $_CONFIG->params("system");
        $uCnfg = $_CONFIG->userparams("jcomments", $params[0]);

        @require_view("profile_view");
        @import_helper("avatar");
        @import_helper("menu");

        $profile = $JOOMUNITY->user((int)$params[0]);
        $title = (!empty($userCnfg["widgettitle"])) ? $userCnfg["widgettitle"] : JText::_('Comments');
        $picture = get_profile_picture(null, $params[0]);
        $usermenu = user_menu($this->joomunity);
        $sidebar = array($picture, $usermenu);
        $horizmenu = profile_menu();
        $cnfglink = JOOM_LIVE . CMD . "JComments.settings." . UID . CLEAN . "\" rel=\"facebox";
        $headtag = '';
        if (UID <> $profile->id) {
            $headtag = "...";
        }


        $comments = JPATH_SITE . DS . 'components' . DS . 'com_jcomments' . DS . 'jcomments.php';
        if (is_file($comments)) {
        	require_once($comments);
        }

	$comments = JComments::showComments($profile->id, 'com_joomunity');

        //build the page and return it!
        $_page = profile_view::profile_page($title, $horizmenu, $headtag, null, $message, $comments, $sidebar);

        return $this->joomunity->view->set_var("mainbody", $_page);

    }

    function settings($params)
    {
        global $_CONFIG;

        $view = $this->joomunity->view;
        $form = $_CONFIG->userform("jcomments");

        return $view->set_var("mainbody", $form);
    }

    function save_config($params)
    {
        global $JOOMUNITY;

        $model = $this->model;

        JRequest::checkToken() or jexit('Invalid Token');

        $post = JRequest::get('post');
        //save just the form elements we secify as n before!
        foreach ($post as $param => $value) {
            if (substr($param, 0, 2) == "n_") {
                $txt .= trim(substr($param, 2)) . "=" . trim(strip_tags($value)) . "\n";
            }
        }
        $app = $JOOMUNITY->get_instance("applications", "model", "profile");
        //save the INI text
        if (!$app->saveconfig("jcomments", $txt, UID)) {

        }
        $this->all(array(UID), JText::_('Saved'));
    }

    function about($params)
    {
        global $tpl;
        $about = file_get_contents(JOOM_PATH_APP . "JComments" . DS . "description.txt");

        return $tpl->set_var("mainbody", $about);
    }

    function _jcomments_widget($profileid)
    {

        global $_CONFIG, $tpl;

        $comments = JPATH_SITE . DS . 'components' . DS . 'com_jcomments' . DS . 'jcomments.php';
        if (is_file($comments)) {
        	require_once($comments);
        } else {
        	return null;
        }

        //get both users and system configuration!
        $userCnfg = $_CONFIG->userparams("jcomments", (int)$profileid);
        $cmtsCnfg = $_CONFIG->params("jcomments");
        //if this user does not want to show a commenting box on his profile
        if ((bool)$userCnfg["showcommentwidget"] <> true) {
            return false;
        }

	$cmts = JComments::showComments($profileid, 'com_joomunity');

        $name = "jcomments";
        $id = "jcomments_id";
        $icon = JOOM_LIVE_SITE . 'applications/JComments/assets/jcomments16x16.png';
        $title = (!empty($userCnfg["widgettitle"])) ? $userCnfg["widgettitle"] : JText::_('Comments');
        $cfglink = "JComments.settings." . UID;
        $link = JOOM_LIVE . CID . CMD . "JComments.view." . $profileid;
        $close = (UID <> $profileid) ? "none" : "block";
        $toggle = "block";
        $settings = (UID <> $profileid) ? "none" : "block";
        $footer = "";

        unset($userCnfg);
        unset($cmtsCnfg);

        $widget = joom_view::widget($name, $id, $icon, $title, $close, $toggle, $settings, $cmts, $footer, $cfglink);

        return $widget;
    }

    function _default($params)
    {
        return $this->all($params);
    }
}
?>
